import sys
import bigtrak

class LOGOInterp:
  def __init__(self, code):
    self.code = code.splitlines()
    for i in range(len(self.code)):
      self.code[i] = self.code[i].split(";")[0].strip()
      self.code[i] = self.code[i].split()
    self.line = 0
    self.word = 0

    self.output = bigtrak.BigTrak()
    self.functions = {}
    self.functions["BACK"] = self.back
    self.functions["BK"] = self.back
    self.functions["FORWARD"] = self.forward
    self.functions["FD"] = self.forward
    self.functions["LEFT"] = self.left
    self.functions["LT"] = self.left
    self.functions["RIGHT"] = self.right
    self.functions["RT"] = self.right
    self.functions["FIRE"] = self.fire

    print "\n".join(map(repr,self.code))

  def run(self):
    while self.line < len(self.code):
      if self.code[self.line] == []:
        self.line += 1
      else:
        if not (self.code[self.line][self.word].upper() in self.functions.keys()):
          print "Syntax error, unknown function %s" % (self.code[self.line][self.word])
          return -1
        else:
          self.functions[self.code[self.line][self.word].upper()]()

  def next_word(self, newline=True):
    self.word += 1
    if self.word == len(self.code[self.line]):
      if newline:
        self.word = 0
        self.line += 1
      else:
        print "Syntax error, expected a word before new line"
        return -1

  def forward(self):
    self.next_word(False)
    count = int(self.code[self.line][self.word])
    self.next_word()
    self.output.forward(count)

  def back(self):
    self.next_word(False)
    count = int(self.code[self.line][self.word])
    self.next_word()
    self.output.back(count)

  def left(self):
    self.next_word(False)
    count = int(self.code[self.line][self.word])
    self.next_word()
    self.output.left(count)

  def right(self):
    self.next_word(False)
    count = int(self.code[self.line][self.word])
    self.next_word()
    self.output.right(count)

  def fire(self):
    self.next_word()
    self.output.fire()

if __name__ == "__main__":
  if len(sys.argv) < 2:
    print "Require file argument"
    sys.exit(-2)
  
  fr = file(sys.argv[1], "r")
  d = fr.read()
  fr.close()

  l = LOGOInterp(d)
  l.run()

